/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.benutzerverwaltung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.benutzerverwaltung.entity.Benutzer;
import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerUK;

public abstract class AbstractBenutzerDAO extends de.ivu.elect.jee.entity.AbstractDAO<Benutzer,
        de.ivu.elect.business.benutzerverwaltung.entity.BenutzerPK
    , BenutzerUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractBenutzerDAO.class);

  public AbstractBenutzerDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.benutzerverwaltung.entity.BenutzerPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Benutzer findByPrimaryKey(
        de.ivu.elect.business.benutzerverwaltung.entity.BenutzerPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Benutzer findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Benutzer.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: AllNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Benutzer o WHERE o.mandant=?1<br>
      * SQL: <br>
      */
     public java.util.List<Benutzer> findByAll( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("BENUTZER.All")
                              .setParameter(1, mandantCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByAll - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Benutzer, findByAll - NonUniqueResultException, Parameter: "
           + ", mandant:'"+mandant+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByAll(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: AllOrderByBenutzerkennungNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Benutzer o WHERE o.mandant=?1 ORDER BY o.benutzerkennung<br>
      * SQL: <br>
      */
     public java.util.List<Benutzer> findByAllOrderByBenutzerkennung( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("BENUTZER.AllOrderByBenutzerkennung")
                              .setParameter(1, mandantCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByAllOrderByBenutzerkennung - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Benutzer, findByAllOrderByBenutzerkennung - NonUniqueResultException, Parameter: "
           + ", mandant:'"+mandant+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByAllOrderByBenutzerkennung(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: BenutzerkennungUpperNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Benutzer o WHERE UPPER(o.benutzerkennung) = UPPER(?2) AND o.mandant = ?1<br>
      * SQL: <br>
      */
     public java.util.List<Benutzer> findByBenutzerkennungUpper( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull String benutzerkennung) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  			  String benutzerkennungCheckedAndAttached =  checkAndAttach(benutzerkennung, String.class, "benutzerkennung"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("BENUTZER.BenutzerkennungUpper")
                              .setParameter(1, mandantCheckedAndAttached)
                                        .setParameter(2, benutzerkennungCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByBenutzerkennungUpper - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Benutzer, findByBenutzerkennungUpper - NonUniqueResultException, Parameter: "
           + ", mandant:'"+mandant+"'"
           + ", benutzerkennung:'"+benutzerkennung+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByBenutzerkennungUpper(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: RolleNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Benutzer o WHERE ?1 MEMBER OF o.rolles<br>
      * SQL: <br>
      */
     public java.util.List<Benutzer> findByRolle( @javax.annotation.Nonnull de.ivu.elect.business.benutzerverwaltung.entity.Rolle rolle) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.benutzerverwaltung.entity.Rolle rolleCheckedAndAttached =  checkAndAttach(rolle, de.ivu.elect.business.benutzerverwaltung.entity.Rolle.class, "rolle"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("BENUTZER.Rolle")
                              .setParameter(1, rolleCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Benutzer, findByRolle - NonUniqueResultException, Parameter: "
           + ", rolle:'"+rolle+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByRolle(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.benutzerverwaltung.entity.BenutzerUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.benutzerverwaltung.entity.BenutzerUK uk,
        de.ivu.elect.business.benutzerverwaltung.entity.BenutzerPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.benutzerverwaltung.entity.Benutzer findByUK(de.ivu.elect.business.benutzerverwaltung.entity.BenutzerUK uk){

    try {
     return (de.ivu.elect.business.benutzerverwaltung.entity.Benutzer) getEntityManager().createNamedQuery("BENUTZER.UK")
                  .setParameter(1, uk
                .getBenutzerkennung ()  
              )
             .setParameter(2, uk
                .getMandantUK ()  
                .getNummer ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Benutzer, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}